## mmake 1.17

=== tildeslash/Makefile ===
#
# Makefile created at Sun Oct 18 11:57:57 1998, by mmake
#

# Programs (with common options):
SHELL		= /bin/sh
RM              = rm -f
MV              = mv -f
SED		= sed
XARGS		= xargs
CAT		= cat
FIND            = find
CPP		= cpp -C -P

INSTALL         = install
INSTALL_PROG    = $(INSTALL) -m $(MODE_PROGS)
INSTALL_FILE    = $(INSTALL) -m $(MODE_FILES)
INSTALL_DIR     = $(INSTALL) -m $(MODE_DIRS) -d

# Install modes 
MODE_PROGS      = 755
MODE_FILES      = 644
MODE_DIRS       = 755

# Build programs
JAVAC           = javac
JAVADOC         = javadoc
JAR             = jar

# Build flags
JAVAC_FLAGS     = 
JAVADOC_FLAGS   = -version -author
JAR_FLAGS       = cvf0
JIKES_DEP_FLAG	= +M


# Where to start installing the class files
CLASS_LIBDIR	= 

# The directory to install the jar file in
JAR_LIBDIR	= 

# The directory to install html files generated by javadoc
DOCDIR          = ./doc


# The dependency graph file
MAKEFILE_DEPEND	= makefile.dep

# The name of the jar file to install
JAR_FILE        = 

# 
# The VERSION variable below should be set to a value 
# that will be tested in the .xjava code. 
# 
VERSION		= JAVA1_0


# Packages we should compile
PACKAGES = \
	tildeslash



# ------------------------------------------------------------------- #

# A marker variable for the top level directory
TOPLEVEL	:= .

# Subdirectories with java files:
JAVA_DIRS	:= $(subst .,/,$(PACKAGES)) $(TOPLEVEL)

# All the .xjava source files:
XJAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.xjava))

# All the xjava files to build
XJAVA_OBJS	:= $(XJAVA_SRC:.xjava=.java)

# All the .java source files:
JAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.java))
JAVA_SRC	:= $(JAVA_SRC) $(XJAVA_OBJS)

# Dependency files:
DEPEND_OBJS	:= $(JAVA_SRC:.java=.u)

# Objects that should go into the jar file. (find syntax)
JAR_OBJS	:= \( -name '*.class' -o -name '*.gif' -o -name "*.au" \)

# All the .java source files we should build:
JAVA_OBJS	:= $(XJAVA_OBJS:.java=.class) $(JAVA_SRC:.java=.class)

# All the java .class files we should install (including inner classes):
JAVA_INSTALL_OBJS:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.class))

# ------------------------------------------------------------------- #


# Courtesy reint@sys.sol.no:
# Used in $(foreach ...) to check exit value and add a newline in the
# shell commands.  Keep exactly as it is, including the empty line!
define check-exit
|| exit 1

endef

define check-exit-or-clean
|| { $(RM) $@; exit 1; }

endef

# -----------
# Build Rules
# -----------

%.java: %.xjava
	$(CPP) -D$(VERSION) $< $@

%.class: %.java
	$(JAVAC) $(JAVAC_FLAGS) $<

%.jar: $(JAVA_OBJS)
	$(FIND) $(TOPLEVEL) $(JAR_OBJS) -print | $(XARGS) \
	$(JAR) $(JAR_FLAGS) $(JAR_FILE) 

%.u: %.java
	$(JAVAC) $(JIKES_DEP_FLAG) $<


# -------
# Targets
# -------

.PHONY : clean all doc jar install src


all:	src

src:	$(JAVA_OBJS)

help:
	@echo "Usage: make [ src | jar | install | doc | clean | depend ]"

install:
	@echo "Run 'make install-jar' to install a jar file, or run "
	@echo "'make install-classes' to install all classes"


ifneq ($(strip $(JAR_FILE)),)
jar:  $(JAR_FILE)

install-jar: $(JAR_FILE)
	$(INSTALL_DIR) $(JAR_LIBDIR)
	$(INSTALL_FILE) $(JAR_FILE) $(JAR_LIBDIR)
else
install-jar jar: 
	@echo "You must specify a name for the jar file before running"
	@echo "install-jar or jar. See the JAR_FILE variable in the Makefile"
endif


ifneq ($(strip $(CLASS_LIBDIR)),)
install-classes: $(JAVA_OBJS)
	$(INSTALL_DIR) $(CLASS_LIBDIR)
	$(foreach dir, $(JAVA_DIRS), \
		$(INSTALL_DIR) $(CLASS_LIBDIR)/$(dir) $(check-exit))
	$(foreach file, $(JAVA_INSTALL_OBJS), \
		$(INSTALL_FILE) $(file) $(CLASS_LIBDIR)/$(file) \
	$(check-exit))
else
install-classes: 
	@echo "Undefined install dir. for class files. See CLASS_LIBDIR"
endif


ifeq ($(findstring jikes,$(JAVAC)),jikes)
depend: $(DEPEND_OBJS)
	( $(CAT) $(DEPEND_OBJS) | $(SED) '/java/d' > $(MAKEFILE_DEPEND); \
	  $(RM) $(DEPEND_OBJS); )
else
depend: 
	@echo "You must use the jikes compiler to create a dependency graph"
endif


ifneq ($(strip $(PACKAGES)),)
doc:	$(JAVA_SRC)
	$(JAVADOC) -d $(DOCDIR) $(JAVADOC_FLAGS) $(PACKAGES)
else
doc:
	@echo "You must put your source files in package(s) to run"\
	       "make doc"
endif


clean::
	$(FIND) . \( -name '*~' -o -name '#*' \) -exec $(RM) {} \;
	$(FIND) . -name '*.class' -exec $(RM) {} \;


ifeq ($(shell test -d $(DOCDIR) && echo "true"),true)
clean::
	$(FIND) $(DOCDIR) -name '*.html' -exec $(RM) {} \;
endif

ifneq ($(strip $(XJAVA_SRC)),)
clean::
	$(RM) $(XJAVA_OBJS)
endif



# ----------------------------------------
# Include the dependency graph if it exist
# ----------------------------------------
DEPEND	= $(shell test -r $(MAKEFILE_DEPEND) && echo "true")
ifeq ($(DEPEND),true)
	include $(MAKEFILE_DEPEND)
endif

## mmake 1.32

=== tildeslash/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Makefile created at Sun Oct 18 11:57:57 1998, by mmake
+# Makefile created at Fri Oct 16 13:31:34 1998, by mmake
 #
 
 # Programs (with common options):
@@ -57,41 +57,43 @@
 VERSION		= JAVA1_0
 
 
+# ------------------------------------------------------------------- #
+
+
 # Packages we should compile
 PACKAGES = \
 	tildeslash
 
 
 
-# ------------------------------------------------------------------- #
 
 # A marker variable for the top level directory
-TOPLEVEL	:= .
+TOPLEVEL        = .
 
 # Subdirectories with java files:
-JAVA_DIRS	:= $(subst .,/,$(PACKAGES)) $(TOPLEVEL)
+JAVA_DIRS	= $(subst .,/,$(PACKAGES)) $(TOPLEVEL)
 
 # All the .xjava source files:
-XJAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.xjava))
+XJAVA_SRC	= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.xjava))
 
 # All the xjava files to build
-XJAVA_OBJS	:= $(XJAVA_SRC:.xjava=.java)
+XJAVA_OBJS	= $(XJAVA_SRC:.xjava=.java)
 
 # All the .java source files:
-JAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.java))
+JAVA_SRC	= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.java))
 JAVA_SRC	:= $(JAVA_SRC) $(XJAVA_OBJS)
 
 # Dependency files:
-DEPEND_OBJS	:= $(JAVA_SRC:.java=.u)
+DEPEND_OBJS      = $(JAVA_SRC:.java=.u)
 
 # Objects that should go into the jar file. (find syntax)
-JAR_OBJS	:= \( -name '*.class' -o -name '*.gif' -o -name "*.au" \)
+JAR_OBJS         = \( -name '*.class' -o -name '*.gif' -o -name "*.au" \)
 
 # All the .java source files we should build:
-JAVA_OBJS	:= $(XJAVA_OBJS:.java=.class) $(JAVA_SRC:.java=.class)
+JAVA_OBJS	= $(XJAVA_OBJS:.java=.class) $(JAVA_SRC:.java=.class)
 
 # All the java .class files we should install (including inner classes):
-JAVA_INSTALL_OBJS:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.class))
+JAVA_INSTALL_OBJS= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.class))
 
 # ------------------------------------------------------------------- #
 
@@ -160,7 +162,7 @@
 
 
 ifneq ($(strip $(CLASS_LIBDIR)),)
-install-classes: $(JAVA_OBJS)
+install-classes:: $(JAVA_OBJS)
 	$(INSTALL_DIR) $(CLASS_LIBDIR)
 	$(foreach dir, $(JAVA_DIRS), \
 		$(INSTALL_DIR) $(CLASS_LIBDIR)/$(dir) $(check-exit))
@@ -169,7 +171,7 @@
 	$(check-exit))
 else
 install-classes: 
-	@echo "Undefined install dir. for class files. See CLASS_LIBDIR"
+	@echo "Install dir for classes is not defined. See CLASS_LIBDIR"
 endif

## mmake 2.2.1

=== tildeslash/Makefile ===
#
# Makefile created at Mon Jul  2 01:58:15 2001, by mmake
#

# Programs (with common options):
SHELL		= /bin/sh
RM              = rm -f
MV              = mv -f
SED		= sed
ETAGS		= etags
XARGS		= xargs
CAT		= cat
FIND            = find
CPP		= cpp -C -P

INSTALL         = install
INSTALL_PROG    = $(INSTALL) -m $(MODE_PROGS)
INSTALL_FILE    = $(INSTALL) -m $(MODE_FILES)
INSTALL_DIR     = $(INSTALL) -m $(MODE_DIRS) -d

# Install modes 
MODE_PROGS      = 555
MODE_FILES      = 444
MODE_DIRS       = 2755

# Build programs
JAVAC           = javac
JAVADOC         = javadoc
JAR             = jar

# Build flags
JAVAC_FLAGS     = 
JAVADOC_FLAGS   = -version -author
JAR_FLAGS       = cvf0
JIKES_DEP_FLAG	= +M

# ------------------------------------------------------------------- #

# Prefix for every install directory
PREFIX		= 

# Where to start installing the class files. Set this to an empty value
#  if you dont want to install classes
CLASS_DIR	= $(PREFIX)classes

# The directory to install the jar file in. Set this to an empty value
#  if you dont want to install a jar file
JAR_DIR	        = $(PREFIX)lib

# The directory to install html files generated by javadoc
DOC_DIR         = $(PREFIX)doc/api-docs

# The directory to install script files in
SCRIPT_DIR	= $(PREFIX)bin

# ------------------------------------------------------------------- #

# The name of the jar file to install
JAR_FILE        = 

# 
# The VERSION variable below should be set to a value 
# that will be tested in the .xjava code. 
# 
VERSION		= JAVA1_0

# ------------------------------------------------------------------- #


# Packages we should compile
PACKAGES = \
	tildeslash


# Resource packages
RESOURCES = 


# Directories with shell scripts
SCRIPTS = 

# ------------------------------------------------------------------- #

# A marker variable for the top level directory
TOPLEVEL	:= .

# Subdirectories with java files:
JAVA_DIRS	:= $(subst .,/,$(PACKAGES)) $(TOPLEVEL)

# Subdirectories with only resource files:
RESOURCE_DIRS	:= $(subst .,/,$(RESOURCES))

# All the .xjava source files:
XJAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.xjava))

# All the xjava files to build
XJAVA_OBJS	:= $(XJAVA_SRC:.xjava=.java)

# All the .java source files:
JAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.java))
JAVA_SRC	:= $(XJAVA_OBJS) $(JAVA_SRC)

# Dependency files:
DEPEND_OBJS	:= $(JAVA_SRC:.java=.u)

# Objects that should go into the jar file. (find syntax)
JAR_OBJS	:= \( -name '*.class' -o -name '*.gif' -o -name "*.au" \
		       -o -name '*.properties' \)

# The intermediate java files and main classes we should build:
JAVA_OBJS	:= $(XJAVA_OBJS) $(JAVA_SRC:.java=.class)

# Resource files:
#  Extend the list to install other files of your choice
RESOURCE_SRC	:= *.properties *.gif *.au
#  Search for resource files in both JAVA_DIRS and RESOURCE_DIRS
RESOURCE_OBJS	:= $(foreach dir, $(JAVA_DIRS) $(RESOURCE_DIRS), \
		     $(wildcard $(foreach file, $(RESOURCE_SRC), \
		     $(dir)/$(file))))

# All the shell scripts source
SCRIPT_SRCS 	:= $(foreach dir, $(SCRIPTS), $(wildcard $(dir)/*.sh))
# All shell scripts we should install
SCRIPT_OBJS    	:= $(SCRIPT_SRCS:.sh=)

# All the files to install into CLASS_DIR
INSTALL_OBJS	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.class))
# Escape inner class delimiter $
INSTALL_OBJS	:= $(subst $$,\$$,$(INSTALL_OBJS))
# Add the resource files to be installed as well
INSTALL_OBJS	:= $(INSTALL_OBJS) $(RESOURCE_OBJS)


# ------------------------------------------------------------------- #


define check-exit
|| exit 1

endef


# -----------
# Build Rules
# -----------

%.java: %.xjava
	$(CPP) -D$(VERSION) $< $@

%.class: %.java
	$(JAVAC) $(JAVAC_FLAGS) $<

%.jar: $(JAVA_OBJS) $(RESOURCE_OBJS)
	$(FIND) $(TOPLEVEL) $(JAR_OBJS) -print | $(XARGS) \
	$(JAR) $(JAR_FLAGS) $(JAR_FILE) 

%.u: %.java
	$(JAVAC) $(JIKES_DEP_FLAG) $<


# -------
# Targets
# -------

.PHONY: all jar install uninstall doc clean depend tags

all::	$(JAVA_OBJS)


help:
	@echo "Usage: make {all|jar|install|uninstall|doc|clean|depend|tags}"


# Jar target
ifneq ($(strip $(JAR_FILE)),)
jar:  $(JAR_FILE)
ifneq ($(strip $(JAR_DIR)),)
install:: $(JAR_FILE)
	@echo "===> [Installing jar file, $(JAR_FILE) in $(JAR_DIR)] "
	$(INSTALL_DIR) $(JAR_DIR) $(check-exit)
	$(INSTALL_FILE) $(JAR_FILE) $(JAR_DIR) $(check-exit)
uninstall::
	@echo "===> [Removing jar file, $(JAR_FILE) from $(JAR_DIR)] "
	$(RM) $(JAR_DIR)/$(JAR_FILE)  $(check-exit)
else
install::
	@echo "No jar install dir defined"
endif
clean::
	$(RM) $(JAR_FILE)
else
jar:
	@echo "No jar file defined"
endif



# Install target for Classes and Resources 
ifneq ($(strip $(CLASS_DIR)),)
install:: $(JAVA_OBJS)
	@echo "===> [Installing classes in $(CLASS_DIR)] "
	$(INSTALL_DIR) $(CLASS_DIR) $(check-exit)
	$(foreach dir, $(JAVA_DIRS) $(RESOURCE_DIRS), \
		$(INSTALL_DIR) $(CLASS_DIR)/$(dir) $(check-exit))
	$(foreach file, $(INSTALL_OBJS), \
		$(INSTALL_FILE) $(file) $(CLASS_DIR)/$(file) \
	$(check-exit))
uninstall::
	@echo "===> [Removing class-files from $(CLASS_DIR)] "
	$(foreach file, $(INSTALL_OBJS), \
		$(RM) $(CLASS_DIR)/$(file) \
	$(check-exit))
else
# Print a warning here if you like. (No class install dir defined)
endif



# Depend target
ifeq ($(findstring jikes,$(JAVAC)),jikes)
depend: $(XJAVA_OBJS) $(DEPEND_OBJS)
	( $(CAT) $(DEPEND_OBJS) |  $(SED) -e '/\.class$$/d' \
	  -e '/.*$$.*/d' > $(MAKEFILE_DEPEND); $(RM) $(DEPEND_OBJS); )
else
depend:
	@echo "mmake needs the jikes compiler to build class dependencies"
endif



# Doc target
ifneq ($(strip $(PACKAGES)),)
doc:	$(JAVA_SRC)
	@echo "===> [Installing java documentation in $(DOC_DIR)] "
	$(INSTALL_DIR) $(DOC_DIR) $(check-exit)
	$(JAVADOC) -d $(DOC_DIR) $(JAVADOC_FLAGS) $(PACKAGES)
else
doc:
	@echo "You must put your source files in a package to run make doc"
endif



# Script target
ifneq ($(strip  $(SCRIPT_OBJS)),)
all::	 $(SCRIPT_OBJS)
ifneq ($(strip $(SCRIPT_DIR)),)
install:: $(SCRIPT_OBJS)
	@echo "===> [Installing shell-scripts in $(SCRIPT_DIR)] "
	$(INSTALL_DIR) $(SCRIPT_DIR) $(check-exit)
	$(foreach file, $(SCRIPT_OBJS), \
		$(INSTALL_PROG) $(file) $(SCRIPT_DIR) $(check-exit))
uninstall:: 
	@echo "===> [Removing shell-scripts from $(SCRIPT_DIR)] "
	$(foreach file, $(SCRIPT_OBJS), \
		$(RM) $(SCRIPT_DIR)/$(file) $(check-exit))
else
# Print a warning here if you like. (No script install dir defined)
endif
clean::
	rm -f $(SCRIPT_OBJS)
endif



# Tag target
tags:	
	@echo "Tagging"
	$(ETAGS) $(filter-out $(XJAVA_OBJS), $(JAVA_SRC)) $(XJAVA_SRC)



# Various cleanup routines
clean::
	$(FIND) . \( -name '*~' -o -name '*.class' \) -print | \
	$(XARGS) $(RM) 
	$(FIND) . -name '*.u' -print | $(XARGS) $(RM)

ifneq ($(strip $(XJAVA_SRC)),)
clean::
	$(RM) $(XJAVA_OBJS)
endif

# ----------------------------------------
# Include the dependency graph if it exist
# ----------------------------------------
MAKEFILE_DEPEND	= makefile.dep
DEPEND	= $(wildcard $(MAKEFILE_DEPEND))
ifneq ($(DEPEND),)
	include $(MAKEFILE_DEPEND)
endif

## mmake 2.3

=== tildeslash/Makefile ===
--- 
+++ 
@@ -1,9 +1,10 @@
 #
-# Makefile created at Mon Jul  2 01:58:15 2001, by mmake
+# Makefile created at Fri Apr  2 04:05:33 2004, by mmake
 #
 
 # Programs (with common options):
 SHELL		= /bin/sh
+CP		= cp
 RM              = rm -f
 MV              = mv -f
 SED		= sed
@@ -47,6 +48,11 @@
 #  if you dont want to install a jar file
 JAR_DIR	        = $(PREFIX)lib
 
+# The directory to install the app bundle in. Set this to an empty value
+#  if you dont want to install an app bundle
+BUNDLE_DIR      = $(PREFIX)lib
+
+
 # The directory to install html files generated by javadoc
 DOC_DIR         = $(PREFIX)doc/api-docs
 
@@ -60,11 +66,40 @@
 
 # 
 # The VERSION variable below should be set to a value 
-# that will be tested in the .xjava code. 
+# that will be tested in the .xjava code and Info.plist. 
 # 
-VERSION		= JAVA1_0
-
-# ------------------------------------------------------------------- #
+VERSION		= JAVA1_1
+
+# ------------------------------------------------------------------- #
+
+# The name of the OS X Application Bundle to install
+BUNDLE_FILE	= 
+
+# Folder containing App Bundle resources (Info.plist, *.icns, etc.)
+BUNDLE_RESOURCE_DIR = misc/macosx
+
+# Items to copy to the Resources folder of the bundle
+BUNDLE_RESOURCES = $(addsuffix .icns, $(basename $(APP_FILE)) Document)
+
+# Location of JavaApplicatonStub
+JAVA_STUB	= /System/Library/Frameworks/JavaVM.framework/Resources/MacOS/JavaApplicationStub
+
+# ------------------------------------------------------------------- #
+
+# Resource files:
+#  Extend the list to install other files of your choice
+RESOURCE_SRC	:= *.properties *.gif *.au
+
+# Objects that should go into the jar file. (find syntax)
+JAR_OBJS	:= \( -name '*.class' -o -name '*.gif' -o -name "*.au" \
+		       -o -name '*.properties' \)
+
+# Include the separate variables file if it exists
+MAKEFILE_VARS	= makefile.vars
+VARS	= $(wildcard $(MAKEFILE_VARS))
+ifneq ($(VARS),)
+	include $(MAKEFILE_VARS)
+endif
 
 
 # Packages we should compile
@@ -72,6 +107,15 @@
 	tildeslash
 
 
+# All packages that can be recursively compiled.
+ALL_PACKAGES = \
+	$(PACKAGES)
+
+
+# Packages to generate docs for.
+JAVADOC_PACKAGES = $(PACKAGES)
+
+
 # Resource packages
 RESOURCES = 
 
@@ -95,6 +139,15 @@
 
 # All the xjava files to build
 XJAVA_OBJS	:= $(XJAVA_SRC:.xjava=.java)
+
+# Directory coresponding to a package
+PACKAGE_DIR	= $(subst .,/,$(1))
+
+# All the (x)java files in a package
+PACKAGE_SRC	=  $(shell $(FIND) $(PACKAGE_DIR) \( -name '*.java' -or -name '*.xjava' \) )
+
+# All the classes to build in a package
+PACKAGE_OBJS	= $(patsubst %.java,%.class,$(PACKAGE_SRC: %.xjava=%.java))
 
 # All the .java source files:
 JAVA_SRC	:= $(foreach dir, $(JAVA_DIRS), $(wildcard $(dir)/*.java))
@@ -103,16 +156,9 @@
 # Dependency files:
 DEPEND_OBJS	:= $(JAVA_SRC:.java=.u)
 
-# Objects that should go into the jar file. (find syntax)
-JAR_OBJS	:= \( -name '*.class' -o -name '*.gif' -o -name "*.au" \
-		       -o -name '*.properties' \)
-
 # The intermediate java files and main classes we should build:
 JAVA_OBJS	:= $(XJAVA_OBJS) $(JAVA_SRC:.java=.class)
 
-# Resource files:
-#  Extend the list to install other files of your choice
-RESOURCE_SRC	:= *.properties *.gif *.au
 #  Search for resource files in both JAVA_DIRS and RESOURCE_DIRS
 RESOURCE_OBJS	:= $(foreach dir, $(JAVA_DIRS) $(RESOURCE_DIRS), \
 		     $(wildcard $(foreach file, $(RESOURCE_SRC), \
@@ -162,13 +208,28 @@
 # Targets
 # -------
 
-.PHONY: all jar install uninstall doc clean depend tags
+.PHONY: all jar install uninstall doc clean depend tags bundle \
+	help $(ALL_PACKAGES)
 
 all::	$(JAVA_OBJS)
 
-
 help:
-	@echo "Usage: make {all|jar|install|uninstall|doc|clean|depend|tags}"
+	@echo "Usage: make {all|jar|srcjar|bundle|install|uninstall|doc|clean|depend|tags|PACKAGE_NAME}"
+	@echo "	all: build all classes"
+	@echo "	jar: build jar file"
+	@echo "	srcjar: build source jar file"
+	@echo "	bundle: build OS X app bundle"
+	@echo "	install: install classes into $(CLASS_DIR)"
+	@echo "		jar into $(JAR_DIR)"
+	@echo "		bundle into $(BUNDLE_DIR)"
+	@echo "		javadocs into $(DOC_DIR)"
+	@echo "		scripts into $(SCRIPT_DIR)"
+	@echo "	uninstall: remove installed files"
+	@echo "	doc: generate api docs from javadoc comments"
+	@echo "	clean: remove classes and temporary files"
+	@echo "	depend: build class dependency info using jikes"
+	@echo "	tags: build emacs tags file"
+	@echo "	PACKAGE_NAME: builds all classes in this package and any subpackages."
 
 
 # Jar target
@@ -193,6 +254,53 @@
 	@echo "No jar file defined"
 endif
 
+SRC_JAR_FILE := $(basename $(JAR_FILE))-src$(suffix $JAR_FILE)
+
+# Source jar target
+srcjar : $(SRC_JAR_FILE)
+$(SRC_JAR_FILE): $(JAVA_SRC) $(RESOURCE_OBJS)
+	$(FIND) $(TOPLEVEL) $(JAR_OBJS: .class=.java) -print | $(XARGS) \
+	$(JAR) $(JAR_FLAGS) $@
+
+# Bundle target
+ifneq ($(strip $(BUNDLE_FILE)),)
+bundle:  $(BUNDLE_FILE)
+$(BUNDLE_FILE) : $(JAR_FILE)
+	$(INSTALL_DIR) $(BUNDLE_FILE)/Contents/Resources/Java $(check-exit)
+	$(INSTALL_DIR) $(BUNDLE_FILE)/Contents/MacOS $(check-exit)
+	$(INSTALL_PROG) $(JAVA_STUB) $(BUNDLE_FILE)/Contents/MacOS/ \
+		$(check-exit)
+	( $(CAT) $(BUNDLE_RESOURCE_DIR)/Info.plist | $(SED) -e \
+		s/VERSION/$(VERSION)/ >98762infoplist876 ) $(check-exit)
+	$(INSTALL_FILE) 98762infoplist876 \
+		$(BUNDLE_FILE)/Contents/Info.plist $(check-exit)
+	$(RM) 98762infoplist876 $(check-exit)
+	$(INSTALL_FILE) $(JAR_FILE) $(BUNDLE_FILE)/Contents/Resources/Java
+	checkexit="";for f in $(BUNDLE_RESOURCES); do \
+		$(INSTALL_FILE) $(BUNDLE_RESOURCE_DIR)$$f $(BUNDLE_FILE)/Contents/Resources/ \
+		|| checkexit=$?; \
+		done; test -z $$checkexit
+
+ifneq ($(strip $(BUNDLE_DIR)),)
+# This is probably bad, but I don't know how else to do it
+install:: $(BUNDLE_FILE)
+	@echo "===> [Installing app bundle, $(BUNDLE_FILE) in $(BUNDLE_DIR)] "
+	$(INSTALL_DIR) $(BUNDLE_DIR) $(check-exit)
+	$(CP) -R $(BUNDLE_FILE) $(BUNDLE_DIR) $(check-exit)
+	$(INSTALL_FILE) $(BUNDLE_FILE) $(BUNDLE_DIR) $(check-exit)
+uninstall::
+	@echo "===> [Removing bundle file, $(BUNDLE_FILE) from $(BUNDLE_DIR)] "
+	$(RM) -r $(BUNDLE_DIR)/$(BUNDLE_FILE)  $(check-exit)
+else
+install::
+	@echo "No bundle install dir defined"
+endif
+clean::
+	$(RM) -r $(BUNDLE_FILE)
+else
+bundle:
+	@echo "No bundle file defined"
+endif
 
 
 # Install target for Classes and Resources 
@@ -229,11 +337,11 @@
 
 
 # Doc target
-ifneq ($(strip $(PACKAGES)),)
+ifneq ($(strip $(JAVADOC_PACKAGES)),)
 doc:	$(JAVA_SRC)
 	@echo "===> [Installing java documentation in $(DOC_DIR)] "
 	$(INSTALL_DIR) $(DOC_DIR) $(check-exit)
-	$(JAVADOC) -d $(DOC_DIR) $(JAVADOC_FLAGS) $(PACKAGES)
+	$(JAVADOC) $(JAVADOC_FLAGS) -d $(DOC_DIR) $(JAVADOC_PACKAGES)
 else
 doc:
 	@echo "You must put your source files in a package to run make doc"
@@ -290,3 +398,6 @@
 	include $(MAKEFILE_DEPEND)
 endif
 
+#package targets
+tildeslash : $(call PACKAGE_OBJS,tildeslash)
+

=== debian/changelog ===
mmake (2.3-8) unstable; urgency=medium

  * QA upload.
  * Bump debhelper compat to v13.
  * Bump Standards-Version to 4.5.1.
  * Source-only upload.

 -- Boyuan Yang <byang@debian.org>  Thu, 31 Dec 2020 14:20:58 -0500

mmake (2.3-7) unstable; urgency=medium

  * QA upload.
  * Migrated to DebSrc 3.0.
  * debian/clean:
      - Created to remove Makefile after building.
  * debian/control:
      - Update DH level from 4 to 9. (Closes: #817585)
      - Added Homepage field.
      - Added the ${misc:Depends} variable to provide the right install
        dependencies.
      - Bumped Standards-Version to 3.9.8.
      - Set correct priority to optional.
      - Using dh-autoreconf now.
  * debian/copyright:
      - Migrated to 1.0 format.
      - Updated all information.
  * debian/dirs: unnecessary. Removed.
  * debian/patches (quilt):
      - mmake_2.3-6.diff.gz splited:
          -mmake-output-file.diff:
             ~ Renamed to mmake-output-file.patch.
             ~ Added a header.
          -fix-manpage.patch:
             ~ fixes a few typo in manpage.
          -all the Makefile file was being provided by patch until previous
           revision. Now, using dh-autoreconf, it's being generated
           at build time
  * debian/rules:
      - Updated to new (reduced) format.
      - Created override_dh_auto_install to fix Makefile patch.
  * debian/watch:
      - Bumped to version 4.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sat, 02 Jul 2016 13:33:20 -0300

mmake (2.3-6) unstable; urgency=high

  * QA upload
  * Set Maintainer to Debian QA Group
  * Change dependency on perl5 to perl following the removal of
    the former (Closes: #808220)

 -- Dominic Hargreaves <dom@earth.li>  Thu, 17 Dec 2015 11:47:57 +0000

mmake (2.3-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control (Build-Depends): Replaced jikes with default-jdk.
    (Recommends): Likewise, closes: #528065.

 -- Michael Banck <mbanck@debian.org>  Sun, 29 Nov 2009 11:51:00 +0100

mmake (2.3-5) unstable; urgency=low

  * mmake.1: Properly escape "-" characters in invocation synopsis since
    they should be minus signs, not hyphens.
  
  * debian/copyright: Give proper copyright notice.

 -- Thomas Bushnell, BSG <tb@debian.org>  Sun, 24 Feb 2008 18:55:32 -0500

mmake (2.3-4) unstable; urgency=low

  * debian/control (Standards-Version): Update to 3.7.3.  No changes needed.
    
  * debian/rules (clean): Don't ignore all errors on Make clean invocation.
    Fixes lintian warning debian-rules-ignores-make-clean-error.

 -- Thomas Bushnell, BSG <tb@debian.org>  Mon, 14 Jan 2008 16:11:11 -0500

mmake (2.3-3) unstable; urgency=low

  * debian/control (Standards-Version): Update to 3.7.2.
  
  * debian/control (Build-Depends-Indep): Remove debhelper.
  (Build-Depends): Add debhelper.
  
  * debian/control: Add final newline.

 -- Thomas Bushnell, BSG <tb@debian.org>  Tue,  3 Oct 2006 00:04:55 -0700

mmake (2.3-2) unstable; urgency=low

  * debian/copyright: Update FSF address.
    
  * debian/control (Standards-Version): Now 3.6.2.
    
  * debian/compat: New file; now 4.
  * debian/rules (install): Install into debian/mmake.
  
 -- Thomas Bushnell, BSG <tb@debian.org>  Fri, 30 Sep 2005 22:33:22 -0700

mmake (2.3-1) unstable; urgency=low

  * New upstream release.
  
  * debian/watch: New file.

 -- Thomas Bushnell, BSG <tb@debian.org>  Fri, 30 Sep 2005 21:34:54 -0700

mmake (2.2.1-6) unstable; urgency=low

  * Actually set new maintainer.  Whoops.

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 18 Aug 2004 11:35:51 -0700

mmake (2.2.1-5) unstable; urgency=low

  * New maintainer.  Closes: #261581.

 -- Thomas Bushnell, BSG <tb@debian.org>  Wed, 18 Aug 2004 01:19:52 -0700

mmake (2.2.1-4) unstable; urgency=low

  * QA upload.
  * Made depends on findutils versioned, closes: #216534.
  * Updated standards version from 3.0.1 to 3.6.1.
  * Updated copyright file so it include GPL in a correct way, closes: #255955.
  * Applied patch from Matt Zimmerman <mdz@debian.org> to allow output
    of other file than Makefile, closes: #199875.
  * Removed emacs variables from bottom of this changelog.
  * Removed dh_make examples from debian dir.
  * Made build depends indep instead of build depends.
  * Changed recommends from java-compiler to jikes | java-compiler.
  * Remved dh_suidregister from debian/rules.

 -- Ola Lundqvist <opal@debian.org>  Tue, 17 Aug 2004 09:43:19 +0200

mmake (2.2.1-3) unstable; urgency=low

  * Orphaned this package.

 -- John Goerzen <jgoerzen@complete.org>  Mon, 26 Jul 2004 15:01:52 -0500

mmake (2.2.1-2) unstable; urgency=low

  * Added build-dep for debhelper.  Closes: #133704.

 -- John Goerzen <jgoerzen@complete.org>  Wed, 13 Feb 2002 09:15:10 -0500

mmake (2.2.1-1) unstable; urgency=low

  * New upstream release.
  * Added dependency on findutils for xargs.

 -- John Goerzen <jgoerzen@complete.org>  Wed, 18 Jul 2001 11:21:41 -0500

mmake (1.32-2) unstable; urgency=low

  * Eliminated duplicate manpage.  Closes: #56318.

 -- John Goerzen <jgoerzen@complete.org>  Sun, 13 Feb 2000 19:07:46 -0600

mmake (1.32-1) unstable; urgency=low

  * New upstream release
  * Updated Standards-Version
  * Now FHS.
  * Changed Reccommends and Depends.  Closes: #44465.
  * Closed out old bug: #41470.

 -- John Goerzen <jgoerzen@complete.org>  Tue, 21 Sep 1999 13:15:01 -0500

mmake (1.17-1.1) unstable; urgency=low

  * NMU for the perl upgrade. Closes: #41470
  * Corrected the perl dependency.
  * Upgraded standards-version to 2.5.1.
  * Removed the empty README.debian file.

 -- Raphael Hertzog <rhertzog@hrnet.fr>  Thu, 22 Jul 1999 20:32:23 +0200

mmake (1.17-1) unstable; urgency=low

  * New upstream release; has performance enhancements with recursion.

 -- John Goerzen <jgoerzen@complete.org>  Tue, 27 Oct 1998 09:48:50 -0600

mmake (1.16-1) unstable; urgency=low

  * New upstream release
  * Updated rules:clean to not halt if files trying to be cleaned
    aren't there.



=== debian/control ===
Source: mmake
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 4.5.1
Homepage: http://www.tildeslash.com/mmake/
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: default-jdk

Package: mmake
Architecture: all
Depends: findutils (>= 4.0), java-common, perl, ${misc:Depends}
Recommends: default-jdk | java-compiler
Description: Makefile generator for Java programs
 mmake will generate a master Makefile for your Java programs.
 This generated Makefile fully understands the subdirectories
 that are required if your program consists of multiple packages.
 mmake also automatically generates dependencies, and can use
 the C preprocessor for Java programs and generate javadoc documentation.
 mmake defaults to using Sun's javac from the jdk but can easily use
 guavac or a different GPL alternative as well.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- BINDIR=debian/mmake/usr/bin \
			   MANDIR=debian/mmake/usr/share/man/man1

=== debian/watch ===
version=4
http://www.tildeslash.com/mmake/dist/mmake-(.*).tar.gz
